import { BehaviorSubject } from 'rxjs';
import { Title } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';
import { ActivatedRoute, RouterModule } from '@angular/router';
import { InjectionToken, Injectable, ChangeDetectionStrategy, Component, ComponentFactoryResolver, Input, ViewChild, Directive, ViewContainerRef, NgModule, CUSTOM_ELEMENTS_SCHEMA, Inject, Optional, ChangeDetectorRef, defineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var DEMO_COMPONENTS = new InjectionToken('Demo components');
/** @type {?} */
var GET_STARTED_URL = new InjectionToken('URL to get started from home');
/** @type {?} */
var HOME_README = new InjectionToken('Injectable Home Readme');
/** @type {?} */
var MODULE_DOCS = new InjectionToken('Demo components');
/** @type {?} */
var MODULE_GET_STARTED_URL = new InjectionToken('URL to try a module');
/** @type {?} */
var MODULE_NAME = new InjectionToken('Module name');
/** @type {?} */
var MODULE_README = new InjectionToken('Injectable Web Components Readme');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DocsService = /** @class */ (function () {
    function DocsService() {
        this._menuItems$ = new BehaviorSubject(null);
    }
    Object.defineProperty(DocsService.prototype, "menuItems$", {
        get: /**
         * @return {?}
         */
        function () {
            return this._menuItems$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocsService.prototype, "menuItems", {
        set: /**
         * @param {?} items
         * @return {?}
         */
        function (items) {
            this._menuItems = items;
            this._menuItems$.next(items);
        },
        enumerable: true,
        configurable: true
    });
    DocsService.decorators = [
        { type: Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ DocsService.ngInjectableDef = defineInjectable({ factory: function DocsService_Factory() { return new DocsService(); }, token: DocsService, providedIn: "root" });
    return DocsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var baseTitle = function (title) {
    return title.includes('|') ? title.split(' | ')[0] : title;
};
/** @type {?} */
var titleFromName = function (name) {
    return name.split(/(?=[A-Z])/).join(' ');
};
/** @type {?} */
var titleFromTag = function (tag) {
    return tag.split('-').slice(1).map(function (word) { return word.charAt(0).toUpperCase() + word.slice(1); }).join(' ');
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var HomeComponent = /** @class */ (function () {
    function HomeComponent(title, service, getStartedUrl, readme) {
        this.title = title;
        this.service = service;
        this.getStartedUrl = getStartedUrl;
        this.readme = readme;
        this.service.menuItems = null;
        this.title.setTitle(baseTitle(this.title.getTitle()));
    }
    HomeComponent.decorators = [
        { type: Component, args: [{
                    template: "<article>\n    <ad-markdown [data]=\"readme\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <ad-button [routerLink]=\"getStartedUrl\" size=\"large\">Get Started</ad-button>\n    </p>\n</article>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    HomeComponent.ctorParameters = function () { return [
        { type: Title },
        { type: DocsService },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [GET_STARTED_URL,] }] },
        { type: String, decorators: [{ type: Inject, args: [HOME_README,] }] }
    ]; };
    return HomeComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureComponent = /** @class */ (function () {
    function FeatureComponent(route, changeRef, title, allDemos, docs) {
        var _this = this;
        this.route = route;
        this.changeRef = changeRef;
        this.title = title;
        this.allDemos = allDemos;
        this.docs = docs;
        this.routeSub = this.route.params.subscribe(function (params) {
            _this.compDoc = _this.docs.find(function (doc) {
                return doc.tag ? doc.tag === params.id : doc.name === params.id;
            });
            _this.hasUsages = !!(_this.compDoc && _this.compDoc.usage);
            _this.isAngular = _this.compDoc && !_this.compDoc.tag;
            _this.title.setTitle(_this.titleFromDoc(_this.title.getTitle()));
            _this.demos = _this.allDemos.filter(function (demo) { return demo.feature === params.id; });
            _this.changeRef.markForCheck();
        });
    }
    /**
     * @return {?}
     */
    FeatureComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.routeSub.unsubscribe();
    };
    /**
     * @return {?}
     */
    FeatureComponent.prototype.hasApi = /**
     * @return {?}
     */
    function () {
        if (this.isAngular) {
            return this.compDoc
                && ((this.compDoc.inputs && this.compDoc.inputs.length > 0)
                    || (this.compDoc.outputs && this.compDoc.outputs.length > 0)
                    || this.compDoc.methods.length > 0);
        }
        else {
            return this.compDoc && (this.compDoc.props.length > 0 || this.compDoc.events.length > 0 || this.compDoc.methods.length > 0);
        }
    };
    /**
     * @private
     * @param {?} title
     * @return {?}
     */
    FeatureComponent.prototype.titleFromDoc = /**
     * @private
     * @param {?} title
     * @return {?}
     */
    function (title) {
        /** @type {?} */
        var base = baseTitle(title);
        if (!this.compDoc) {
            return base;
        }
        return base + " | " + (this.compDoc.tag ? titleFromTag(this.compDoc.tag) : titleFromName(this.compDoc.name));
    };
    FeatureComponent.decorators = [
        { type: Component, args: [{
                    template: "<div class=\"row\">\n    <div [ngClass]=\"hasUsages ? 'col-12 col-lg-10' : 'col-12'\">\n        <article class=\"component-readme\" id=\"overview\">\n            <ad-markdown [data]=\"compDoc ? compDoc.readme : null\"></ad-markdown>\n        </article>\n        <article *ngFor=\"let demo of demos\" id=\"{{demo.usage}}\">\n            <ad-use-case [demo]=\"demo\" [usage]=\"hasUsages ? compDoc.usage[demo.usage] : null\"></ad-use-case>\n        </article>\n        <article id=\"api\" class=\"api\" *ngIf=\"hasApi()\" [class.ng]=\"isAngular\">\n            <h2>API</h2>\n            <ng-container *ngIf=\"isAngular; else stencilApi\">\n                <ad-input-def *ngFor=\"let input of compDoc.inputs\" [input]=\"input\"></ad-input-def>\n                <ad-output-def *ngFor=\"let output of compDoc.outputs\" [output]=\"output\"></ad-output-def>\n                <ad-prop-def *ngFor=\"let prop of compDoc.props\" [prop]=\"prop\"></ad-prop-def>\n            </ng-container>\n            <ng-template #stencilApi>\n                <ad-prop-def *ngFor=\"let prop of compDoc.props\" [prop]=\"prop\"></ad-prop-def>\n                <ad-event-def *ngFor=\"let event of compDoc.events\" [event]=\"event\"></ad-event-def>\n            </ng-template>\n            <ad-method-def *ngFor=\"let method of compDoc.methods\" [method]=\"method\"></ad-method-def>\n        </article>\n    </div>\n    <div *ngIf=\"hasUsages\" class=\"d-none d-lg-flex col-lg-2 toc-wrapper\">\n        <ad-toc [docs]=\"compDoc.usage\" [demos]=\"demos\"></ad-toc>\n    </div>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".component-readme{margin-bottom:2.5rem}.api{border-bottom:1px solid var(--anj-border);margin-bottom:3rem;padding-bottom:3rem}.api h2{color:var(--anj-primary);margin-bottom:1.5rem}"]
                }] }
    ];
    /** @nocollapse */
    FeatureComponent.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: ChangeDetectorRef },
        { type: Title },
        { type: Array, decorators: [{ type: Inject, args: [DEMO_COMPONENTS,] }] },
        { type: Array, decorators: [{ type: Inject, args: [MODULE_DOCS,] }] }
    ]; };
    return FeatureComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IntroComponent = /** @class */ (function () {
    function IntroComponent(title, readme, moduleName, getStartedUrl) {
        this.title = title;
        this.readme = readme;
        this.moduleName = moduleName;
        this.getStartedUrl = getStartedUrl;
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + moduleName);
    }
    IntroComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ad-components',
                    template: "<article>\n    <ad-markdown [data]=\"readme\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <ad-button [routerLink]=\"getStartedUrl\" size=\"large\">Try It</ad-button>\n    </p>\n</article>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [":host::ng-deep ad-markdown p[align=center]{display:none}"]
                }] }
    ];
    /** @nocollapse */
    IntroComponent.ctorParameters = function () { return [
        { type: Title },
        { type: String, decorators: [{ type: Inject, args: [MODULE_README,] }] },
        { type: String, decorators: [{ type: Inject, args: [MODULE_NAME,] }] },
        { type: String, decorators: [{ type: Optional }, { type: Inject, args: [MODULE_GET_STARTED_URL,] }] }
    ]; };
    return IntroComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DemoHostDirective = /** @class */ (function () {
    function DemoHostDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    DemoHostDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[adDemoHost]'
                },] }
    ];
    /** @nocollapse */
    DemoHostDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return DemoHostDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UseCaseComponent = /** @class */ (function () {
    function UseCaseComponent(resolver) {
        this.resolver = resolver;
    }
    /**
     * @return {?}
     */
    UseCaseComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var factory = this.resolver.resolveComponentFactory(this.demo);
        this.demoHost.viewContainerRef.createComponent(factory);
    };
    UseCaseComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ad-use-case',
                    template: "<ad-markdown [data]=\"usage\"></ad-markdown>\n<div class=\"demo-container\">\n    <ng-template adDemoHost></ng-template>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [":host{border-bottom:1px solid var(--anj-border);display:block;margin-bottom:3rem;padding-bottom:3.5rem}"]
                }] }
    ];
    /** @nocollapse */
    UseCaseComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver }
    ]; };
    UseCaseComponent.propDecorators = {
        demo: [{ type: Input }],
        usage: [{ type: Input }],
        demoHost: [{ type: ViewChild, args: [DemoHostDirective,] }]
    };
    return UseCaseComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AnjunaDocsModule = /** @class */ (function () {
    function AnjunaDocsModule() {
    }
    AnjunaDocsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        RouterModule
                    ],
                    declarations: [
                        FeatureComponent,
                        IntroComponent,
                        UseCaseComponent,
                        DemoHostDirective,
                        HomeComponent
                    ],
                    exports: [
                        FeatureComponent,
                        IntroComponent,
                        HomeComponent
                    ],
                    entryComponents: [
                        FeatureComponent,
                        IntroComponent,
                        HomeComponent
                    ],
                    schemas: [
                        CUSTOM_ELEMENTS_SCHEMA
                    ]
                },] }
    ];
    return AnjunaDocsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { HomeComponent, FeatureComponent, IntroComponent, DEMO_COMPONENTS, GET_STARTED_URL, HOME_README, MODULE_DOCS, MODULE_GET_STARTED_URL, MODULE_NAME, MODULE_README, DocsService, baseTitle, titleFromName, titleFromTag, AnjunaDocsModule, DemoHostDirective as ɵb, UseCaseComponent as ɵa };

//# sourceMappingURL=anjuna-angular-docs.js.map